8821cu-20210916/install-driver.sh

436 lines
14 KiB
Bash
Raw Permalink Normal View History

#!/bin/sh
2022-11-17 14:26:57 +00:00
# Purpose: Install Realtek out-of-kernel USB WiFi adapter drivers.
#
# Supports dkms and non-dkms installations.
2023-01-22 07:52:24 +00:00
#
# To make this file executable:
#
2023-02-12 23:36:39 +00:00
# $ chmod +x install-driver.sh
2023-01-22 07:52:24 +00:00
#
# To execute this file:
#
2023-02-12 23:36:39 +00:00
# $ sudo ./install-driver.sh
#
# or
#
2023-02-19 20:03:53 +00:00
# $ sudo sh install-driver.sh
2023-01-22 07:52:24 +00:00
#
2023-01-08 05:16:17 +00:00
# Copyright(c) 2023 Nick Morrow
2022-12-08 14:10:21 +00:00
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
2022-11-17 14:26:57 +00:00
SCRIPT_NAME="install-driver.sh"
2023-11-25 21:25:49 +00:00
SCRIPT_VERSION="20231115"
MODULE_NAME="8821cu"
2023-09-25 15:04:26 +00:00
DRV_NAME="rtl8821cu"
2022-11-17 14:26:57 +00:00
DRV_VERSION="5.12.0.4"
2023-11-25 21:25:49 +00:00
DRV_DIR="$(pwd)"
2022-11-17 14:26:57 +00:00
2023-11-25 21:25:49 +00:00
OPTIONS_FILE="${MODULE_NAME}.conf"
2022-11-17 14:26:57 +00:00
2023-09-25 15:04:26 +00:00
#KARCH="$(uname -m)"
if [ -z "${KARCH+1}" ]; then
KARCH="$(uname -m)"
fi
#KVER="$(uname -r)"
if [ -z "${KVER+1}" ]; then
KVER="$(uname -r)"
fi
2023-11-25 21:25:49 +00:00
MODDESTDIR="/lib/modules/${KVER}/kernel/drivers/net/wireless/"
2023-09-25 15:04:26 +00:00
#GARCH="$(uname -m | sed -e "s/i.86/i386/; s/ppc/powerpc/; s/armv.l/arm/; s/aarch64/arm64/; s/riscv.*/riscv/;")"
if [ -z "${GARCH+1}" ]; then
GARCH="$(uname -m | sed -e "s/i.86/i386/; s/ppc/powerpc/; s/armv.l/arm/; s/aarch64/arm64/; s/riscv.*/riscv/;")"
fi
# check to ensure sudo or su - was used to start the script
if [ "$(id -u)" -ne 0 ]; then
2022-11-17 14:26:57 +00:00
echo "You must run this script with superuser (root) privileges."
echo "Try: \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2023-01-26 17:52:27 +00:00
# support for the NoPrompt option allows non-interactive use of this script
NO_PROMPT=0
# get the script options
while [ $# -gt 0 ]
do
case $1 in
NoPrompt)
NO_PROMPT=1 ;;
*h|*help|*)
echo "Syntax $0 <NoPrompt>"
echo " NoPrompt - noninteractive mode"
echo " -h|--help - Show help"
exit 1
;;
esac
shift
done
2022-12-08 02:11:44 +00:00
# check to ensure gcc is installed
if ! command -v gcc >/dev/null 2>&1; then
echo "A required package is not installed."
2022-12-08 02:11:44 +00:00
echo "Please install the following package: gcc"
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2023-01-30 18:09:56 +00:00
# check to ensure bc is installed
if ! command -v bc >/dev/null 2>&1; then
echo "A required package is not installed."
echo "Please install the following package: bc"
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
# check to ensure make is installed
if ! command -v make >/dev/null 2>&1; then
echo "A required package is not installed."
echo "Please install the following package: make"
2022-12-06 15:32:40 +00:00
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2023-01-24 19:44:02 +00:00
# check to see if the correct header files are installed
2022-12-12 07:49:04 +00:00
if [ ! -d "/lib/modules/$(uname -r)/build" ]; then
echo "Your kernel header files aren't properly installed."
2023-01-22 07:52:24 +00:00
echo "Please consult your distro documentation or user support forums."
echo "Once the header files are properly installed, please run \"sudo ./${SCRIPT_NAME}\""
2022-12-12 07:49:04 +00:00
exit 1
fi
2023-09-25 15:04:26 +00:00
# ensure /usr/sbin is in the PATH so iw can be found
#if ! echo "$PATH" | grep -qw sbin; then
# export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
#fi
# check to ensure iw is installed
2023-09-25 15:04:26 +00:00
#if ! command -v iw >/dev/null 2>&1; then
# echo "A required package is not installed."
# echo "Please install the following package: iw"
# echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
# exit 1
#fi
2022-11-29 22:20:51 +00:00
# check to ensure rfkill is installed
2023-09-25 15:04:26 +00:00
#if ! command -v rfkill >/dev/null 2>&1; then
# echo "A required package is not installed."
# echo "Please install the following package: rfkill"
# echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
# exit 1
#fi
2022-11-29 22:20:51 +00:00
2023-01-26 17:52:27 +00:00
DEFAULT_EDITOR="$(cat default-editor.txt)"
# try to find the user's default text editor through the EDITORS_SEARCH array
for TEXT_EDITOR in "${VISUAL}" "${EDITOR}" "${DEFAULT_EDITOR}" vi; do
2023-01-25 10:45:40 +00:00
command -v "${TEXT_EDITOR}" >/dev/null 2>&1 && break
done
2023-01-26 17:52:27 +00:00
# fail if no editor was found
if ! command -v "${TEXT_EDITOR}" >/dev/null 2>&1; then
2023-02-09 15:11:23 +00:00
echo "No text editor found (default: ${DEFAULT_EDITOR})."
echo "Please install ${DEFAULT_EDITOR} or edit the file 'default-editor.txt' to specify your editor."
echo "Once complete, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
2022-12-08 02:11:44 +00:00
fi
2023-01-17 15:49:57 +00:00
echo ": ---------------------------"
2022-11-17 14:26:57 +00:00
# displays script name and version
2023-01-10 04:57:46 +00:00
echo ": ${SCRIPT_NAME} v${SCRIPT_VERSION}"
2022-11-17 14:26:57 +00:00
2023-09-25 15:04:26 +00:00
# display kernel architecture
echo ": ${KARCH} (kernel architecture)"
# display architecture to send to gcc
echo ": ${GARCH} (architecture to send to gcc)"
2023-01-08 05:16:17 +00:00
2023-11-25 21:25:49 +00:00
SMEM=$(LC_ALL=C free | awk '/Mem:/ { print $2 }')
2023-01-26 17:52:27 +00:00
sproc=$(nproc)
# avoid Out of Memory condition in low-RAM systems by limiting core usage
if [ "$sproc" -gt 1 ]; then
2023-01-11 17:31:38 +00:00
if [ "$SMEM" -lt 1400000 ]
then
2023-01-17 15:49:57 +00:00
sproc=2
2023-01-11 17:31:38 +00:00
fi
2023-09-25 15:04:26 +00:00
if [ "$SMEM" -lt 700000 ]
then
sproc=1
fi
2023-01-11 17:31:38 +00:00
fi
2023-01-26 17:52:27 +00:00
# display number of in-use processing units / total processing units
echo ": ${sproc}/$(nproc) (in-use/total processing units)"
2023-01-26 17:52:27 +00:00
# display total system memory
echo ": ${SMEM} (total system memory)"
2023-01-08 05:16:17 +00:00
2023-01-08 20:59:04 +00:00
# display kernel version
echo ": ${KVER} (kernel version)"
2023-01-08 20:59:04 +00:00
2023-09-25 15:04:26 +00:00
# display version of gcc used to compile the kernel
gcc_ver_used_to_compile_the_kernel=$(cat /proc/version | sed 's/^.*gcc/gcc/' | sed 's/\s.*$//')
echo ": ""${gcc_ver_used_to_compile_the_kernel} (version of gcc used to compile the kernel)"
2023-01-08 05:16:17 +00:00
# display gcc version
gcc_ver=$(gcc --version | grep -i gcc)
2023-01-26 17:52:27 +00:00
echo ": ""${gcc_ver}"
2023-01-08 20:59:04 +00:00
2023-01-09 20:27:34 +00:00
# display dkms version if installed
if command -v dkms >/dev/null 2>&1; then
2023-01-09 20:27:34 +00:00
dkms_ver=$(dkms --version)
2023-01-26 17:52:27 +00:00
echo ": ""${dkms_ver}"
2023-01-08 20:59:04 +00:00
fi
2023-11-25 21:25:49 +00:00
# display Secure Boot status
if command -v mokutil >/dev/null 2>&1; then
2023-11-25 21:25:49 +00:00
case $(mokutil --sb-state 2>&1) in
*enabled*) echo ": SecureBoot enabled" ;;
*disabled*) echo ": SecureBoot disabled" ;;
*) echo ": This system doesn't support Secure Boot" ;;
esac
2023-09-25 15:04:26 +00:00
else
echo ": mokutil not installed"
2023-01-08 20:59:04 +00:00
fi
2023-01-08 05:16:17 +00:00
2023-01-26 17:52:27 +00:00
echo ": ---------------------------"
2023-02-23 20:29:27 +00:00
echo
2023-09-25 15:04:26 +00:00
echo "Checking for previously installed drivers..."
2023-01-26 17:52:27 +00:00
2022-12-30 18:36:53 +00:00
# check for and remove non-dkms installations
# standard naming
if [ -f "${MODDESTDIR}${MODULE_NAME}.ko" ]; then
2022-12-30 18:36:53 +00:00
echo "Removing a non-dkms installation: ${MODDESTDIR}${MODULE_NAME}.ko"
2023-01-26 17:52:27 +00:00
rm -f "${MODDESTDIR}"${MODULE_NAME}.ko
/sbin/depmod -a "${KVER}"
2023-01-08 05:16:17 +00:00
echo "Removing ${OPTIONS_FILE} from /etc/modprobe.d"
rm -f /etc/modprobe.d/${OPTIONS_FILE}
echo "Removing source files from /usr/src/${DRV_NAME}-${DRV_VERSION}"
rm -rf /usr/src/${DRV_NAME}-${DRV_VERSION}
make clean >/dev/null 2>&1
2023-02-23 20:29:27 +00:00
echo "Removal complete."
2022-11-17 14:26:57 +00:00
fi
2022-12-30 18:36:53 +00:00
# check for and remove non-dkms installations
# with rtl added to module name (PClinuxOS)
if [ -f "${MODDESTDIR}rtl${MODULE_NAME}.ko" ]; then
2022-12-30 18:36:53 +00:00
echo "Removing a non-dkms installation: ${MODDESTDIR}rtl${MODULE_NAME}.ko"
2023-01-26 17:52:27 +00:00
rm -f "${MODDESTDIR}"rtl${MODULE_NAME}.ko
/sbin/depmod -a "${KVER}"
2023-01-08 05:16:17 +00:00
echo "Removing ${OPTIONS_FILE} from /etc/modprobe.d"
rm -f /etc/modprobe.d/${OPTIONS_FILE}
echo "Removing source files from /usr/src/${DRV_NAME}-${DRV_VERSION}"
rm -rf /usr/src/${DRV_NAME}-${DRV_VERSION}
make clean >/dev/null 2>&1
2023-02-23 20:29:27 +00:00
echo "Removal complete."
2022-12-30 18:36:53 +00:00
fi
# check for and remove non-dkms installations
# with compressed module in a unique non-standard location (Armbian)
# Example: /usr/lib/modules/5.15.80-rockchip64/kernel/drivers/net/wireless/rtl8821cu/8821cu.ko.xz
# Dear Armbiam, this is a really bad idea.
if [ -f "/usr/lib/modules/${KVER}/kernel/drivers/net/wireless/${DRV_NAME}/${MODULE_NAME}.ko.xz" ]; then
2022-12-30 18:36:53 +00:00
echo "Removing a non-dkms installation: /usr/lib/modules/${KVER}/kernel/drivers/net/wireless/${DRV_NAME}/${MODULE_NAME}.ko.xz"
2023-01-26 17:52:27 +00:00
rm -f /usr/lib/modules/"${KVER}"/kernel/drivers/net/wireless/${DRV_NAME}/${MODULE_NAME}.ko.xz
/sbin/depmod -a "${KVER}"
2023-01-08 05:16:17 +00:00
echo "Removing ${OPTIONS_FILE} from /etc/modprobe.d"
rm -f /etc/modprobe.d/${OPTIONS_FILE}
echo "Removing source files from /usr/src/${DRV_NAME}-${DRV_VERSION}"
rm -rf /usr/src/${DRV_NAME}-${DRV_VERSION}
make clean >/dev/null 2>&1
2023-02-23 20:29:27 +00:00
echo "Removal complete."
2022-12-30 18:36:53 +00:00
fi
2023-11-25 21:25:49 +00:00
# check for and remove all dkms installations with MODULE_NAME in DRV_NAME
2023-09-25 15:04:26 +00:00
#
if command -v dkms >/dev/null 2>&1; then
2023-09-25 15:04:26 +00:00
dkms status | while IFS="/, " read -r modname modver kerver _dummy; do
case "$modname" in *${MODULE_NAME})
echo "--> ${modname} ${modver} ${kerver}"
dkms remove -m "${modname}" -v "${modver}" -k "${kerver}" -c "/usr/src/${modname}-${modver}/dkms.conf"
esac
done
if [ -f /etc/modprobe.d/${OPTIONS_FILE} ]; then
2023-01-08 05:16:17 +00:00
rm -f /etc/modprobe.d/${OPTIONS_FILE}
2023-09-25 15:04:26 +00:00
fi
if [ -f /usr/src/${DRV_NAME}-${DRV_VERSION} ]; then
2023-01-08 05:16:17 +00:00
rm -rf /usr/src/${DRV_NAME}-${DRV_VERSION}
2022-12-17 22:55:37 +00:00
fi
fi
2023-09-25 15:04:26 +00:00
echo "Finished checking for and removing previously installed drivers."
echo ": ---------------------------"
2023-09-25 15:04:26 +00:00
2023-02-24 19:37:18 +00:00
echo
2023-02-23 20:29:27 +00:00
echo "Starting installation."
2022-12-27 03:57:44 +00:00
echo "Installing ${OPTIONS_FILE} to /etc/modprobe.d"
2022-11-17 14:26:57 +00:00
cp -f ${OPTIONS_FILE} /etc/modprobe.d
# determine if dkms is installed and run the appropriate installation routines
if ! command -v dkms >/dev/null 2>&1; then
2022-11-17 14:26:57 +00:00
echo "The non-dkms installation routines are in use."
2022-11-18 16:36:46 +00:00
make clean >/dev/null 2>&1
2022-11-17 14:26:57 +00:00
2023-01-26 17:52:27 +00:00
make -j"$(nproc)"
2022-11-17 14:26:57 +00:00
RESULT=$?
if [ "$RESULT" != "0" ]; then
echo "An error occurred: ${RESULT}"
2022-11-17 14:26:57 +00:00
echo "Please report this error."
echo "Please copy all screen output and paste it into the problem report."
2022-11-17 14:26:57 +00:00
echo "You will need to run the following before reattempting installation."
2022-11-18 16:36:46 +00:00
echo "$ sudo ./remove-driver.sh"
2022-11-17 14:26:57 +00:00
exit $RESULT
fi
# if secure boot is active, use sign-install
if command -v mokutil >/dev/null 2>&1; then
if mokutil --sb-state | grep -i enabled >/dev/null 2>&1; then
echo ": SecureBoot enabled - read FAQ about SecureBoot"
make sign-install
RESULT=$?
else
make install
RESULT=$?
fi
else
make install
RESULT=$?
fi
if [ "$RESULT" = "0" ]; then
2022-12-15 16:48:43 +00:00
make clean >/dev/null 2>&1
2022-11-17 14:26:57 +00:00
echo "The driver was installed successfully."
echo ": ---------------------------"
echo
2022-11-17 14:26:57 +00:00
else
echo "An error occurred: ${RESULT}"
2022-11-17 14:26:57 +00:00
echo "Please report this error."
echo "Please copy all screen output and paste it into the problem report."
2022-11-17 14:26:57 +00:00
echo "You will need to run the following before reattempting installation."
2022-11-18 16:36:46 +00:00
echo "$ sudo ./remove-driver.sh"
2022-11-17 14:26:57 +00:00
exit $RESULT
fi
else
echo "The dkms installation routines are in use."
# the dkms add command requires source in /usr/src/${DRV_NAME}-${DRV_VERSION}
echo "Copying source files to /usr/src/${DRV_NAME}-${DRV_VERSION}"
2022-11-17 14:26:57 +00:00
cp -rf "${DRV_DIR}" /usr/src/${DRV_NAME}-${DRV_VERSION}
2023-09-25 15:04:26 +00:00
# echo "${DRV_DIR}"
# echo "/usr/src/${DRV_NAME}-${DRV_VERSION}"
2022-12-27 03:57:44 +00:00
2023-09-25 15:04:26 +00:00
dkms add -m ${DRV_NAME} -v ${DRV_VERSION} -k "${KVER}/${KARCH}" -c "/usr/src/${DRV_NAME}-${DRV_VERSION}/dkms.conf"
2022-11-17 14:26:57 +00:00
RESULT=$?
# RESULT will be 3 if the DKMS tree already contains the same module/version
# combo. You cannot add the same module/version combo more than once.
if [ "$RESULT" != "0" ]; then
if [ "$RESULT" = "3" ]; then
2022-12-14 00:28:08 +00:00
echo "This driver may already be installed."
2022-11-17 14:26:57 +00:00
echo "Run the following and then reattempt installation."
echo "$ sudo ./remove-driver.sh"
2022-12-27 03:57:44 +00:00
exit $RESULT
2022-11-17 14:26:57 +00:00
else
echo "An error occurred. dkms add error: ${RESULT}"
2022-11-17 14:26:57 +00:00
echo "Please report this error."
echo "Please copy all screen output and paste it into the problem report."
2022-11-17 14:26:57 +00:00
echo "Run the following before reattempting installation."
echo "$ sudo ./remove-driver.sh"
exit $RESULT
fi
else
2022-12-07 18:02:14 +00:00
echo "The driver was added to dkms successfully."
2023-02-23 20:29:27 +00:00
echo ": ---------------------------"
2023-09-25 15:04:26 +00:00
echo
2022-11-17 14:26:57 +00:00
fi
if command -v /usr/bin/time >/dev/null 2>&1; then
2023-11-25 21:25:49 +00:00
/usr/bin/time -f "Compile time: %U seconds" dkms build -m ${DRV_NAME} -v ${DRV_VERSION} -k "${KVER}/${KARCH}" -c "/usr/src/${DRV_NAME}-${DRV_VERSION}/dkms.conf" --force
else
2023-11-25 21:25:49 +00:00
dkms build -m ${DRV_NAME} -v ${DRV_VERSION} -k "${KVER}/${KARCH}" -c "/usr/src/${DRV_NAME}-${DRV_VERSION}/dkms.conf" --force
fi
2022-11-17 14:26:57 +00:00
RESULT=$?
if [ "$RESULT" != "0" ]; then
echo "An error occurred. dkms build error: ${RESULT}"
2022-11-17 14:26:57 +00:00
echo "Please report this error."
echo "Please copy all screen output and paste it into the problem report."
2022-11-17 14:26:57 +00:00
echo "Run the following before reattempting installation."
echo "$ sudo ./remove-driver.sh"
exit $RESULT
else
2022-12-07 18:02:14 +00:00
echo "The driver was built by dkms successfully."
2023-02-23 20:29:27 +00:00
echo ": ---------------------------"
2022-11-17 14:26:57 +00:00
fi
2023-11-25 21:25:49 +00:00
dkms install -m ${DRV_NAME} -v ${DRV_VERSION} -k "${KVER}/${KARCH}" -c "/usr/src/${DRV_NAME}-${DRV_VERSION}/dkms.conf" --force
2022-11-17 14:26:57 +00:00
RESULT=$?
if [ "$RESULT" != "0" ]; then
echo "An error occurred. dkms install error: ${RESULT}"
2022-11-17 14:26:57 +00:00
echo "Please report this error."
echo "Please copy all screen output and paste it into the problem report."
2022-11-17 14:26:57 +00:00
echo "Run the following before reattempting installation."
echo "$ sudo ./remove-driver.sh"
exit $RESULT
else
2022-12-07 18:02:14 +00:00
echo "The driver was installed by dkms successfully."
2023-02-23 20:29:27 +00:00
echo ": ---------------------------"
echo
2022-11-17 14:26:57 +00:00
fi
fi
# provide driver upgrade information
2023-09-25 15:04:26 +00:00
echo "Info: Update this driver with the following commands as needed:"
echo
echo "$ git pull"
echo "$ sudo sh install-driver.sh"
2023-09-25 15:04:26 +00:00
echo
echo "Note: Updates to this driver SHOULD be performed before distro"
echo " upgrades such as Ubuntu 23.10 to 24.04."
echo "Note: Updates can be performed as often as you like. It is"
echo " recommended to update at least every 2 months."
echo "Note: Work on this driver, like the Linux kernel, is continuous."
echo
echo "Enjoy!"
echo
2022-11-17 14:26:57 +00:00
# unblock wifi
if command -v rfkill >/dev/null 2>&1; then
2022-11-20 04:57:12 +00:00
rfkill unblock wlan
else
2022-12-27 03:57:44 +00:00
echo "Unable to run $ rfkill unblock wlan"
2022-11-20 04:57:12 +00:00
fi
2022-11-17 14:26:57 +00:00
# if NoPrompt is not used, ask user some questions
if [ $NO_PROMPT -ne 1 ]; then
2023-02-27 20:31:22 +00:00
printf "Do you want to edit the driver options file now? (recommended) [Y/n] "
read -r yn
case "$yn" in
2023-03-01 03:32:19 +00:00
[nN]) ;;
*) ${TEXT_EDITOR} /etc/modprobe.d/${OPTIONS_FILE} ;;
esac
2022-11-17 14:26:57 +00:00
2023-02-27 20:31:22 +00:00
printf "Do you want to apply the new options by rebooting now? (recommended) [Y/n] "
read -r yn
case "$yn" in
2023-03-01 03:32:19 +00:00
[nN]) ;;
*) reboot ;;
esac
2022-11-17 14:26:57 +00:00
fi